#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,abm")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int N = 1e6 + 5;
const int infe9 = 1e9 + 5;
const int infe18 = (ll)1e18 + 5;

struct DSU {
    vi pr, sz;
    DSU(int n) {
        pr.resize(n + 5);
        sz.resize(n + 5, 0);
        iota(all(pr), 0);
    }
    int get(int x) {
        return (x == pr[x] ? x : pr[x] = get(pr[x]));
    }
    void unite(int x, int y) {
        x = get(x);
        y = get(y);
        if (x != y) {
            if (sz[x] < sz[y]) swap(x, y);
            pr[y] = x;
            sz[x] += sz[y];
        }
    }
};

int dp[N];
vi g[N];
pii edge[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
        edge[i] = {x, y};
    }
    dp[1] = 1;
    for (int i = 2; i <= m; ++i) {
        dp[i] = i;
        DSU dsu(n);
        vi cur_g[n + 5];
        int j = i - 1;
        for (; j >= 0; --j) {
            if (!j) break;
            auto [x, y] = edge[j];
            cur_g[x].pb(y);
            cur_g[y].pb(x);
            for (int z : cur_g[x]) dsu.unite(y, z);
            for (int z : cur_g[y]) dsu.unite(x, z);
            if (dsu.get(edge[i].x) == dsu.get(edge[i].y)) {
//                cout << i << ' ' << j << '\n';
                break;
            }
        }
        dp[i] = min(dp[i], dp[j] + 1);
    }
    cout << dp[m];
}

int32_t main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    solve();
}
