#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
vector<int> rts, rtc, rt;
void power() {
	rts.resize(n);
	rtc.assign(n, -1);
	rt.resize(n);
	for (int i = 0; i < n; i++) {
		rts[i] = i;
		rt[i] = i;
	}
}
int get_s(int v) {
	if (rts[v] != v)
		rts[v] = get_s(rts[v]);
	return rts[v];
}
int get(int v) {
	if (rt[v] != v)
		rt[v] = get(rt[v]);
	return rt[v];
}
int get_c(int v) {
	if (rtc[v] == -1)
		return -1;
	rtc[v] = get_s(rtc[v]);
	return rtc[v];
}
bool we_can_do_it(int v, int w) {
	int rv = get(v);
	int rw = get(w);
	if (rv != rw)
		return true;
	return (get_s(v) != get_s(w));
}
void join(int v, int w) {
	int rv = get(v);
	int rw = get(w);
	if (rv == rw)
		return;
	rt[rv] = rw; //tobto rv ----> rw
	if (rtc[w] != -1)
		rts[get_s(v)] = get_c(w);
	else
		rtc[w] = get_s(v);
	if (rtc[v] != -1)
		rts[get_c(v)] = get_s(w);
	else
		rtc[v] = get_s(w);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	vector<pair<int, int>> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
	}
	int k = 1;
	power();
	int p = 0;
	for (int i = 0; i < m; i++) {
		if (we_can_do_it(a[i].first, a[i].second)) {
			join(a[i].first, a[i].second);
		}
		else {
			for (int j = p; j < i; j++) {
				rt[a[i].first] = a[i].first;
				rts[a[i].first] = a[i].first;
				rtc[a[i].first] = -1;
				rt[a[i].second] = a[i].second;
				rts[a[i].second] = a[i].second;
				rtc[a[i].second] = -1;
			}
			k++;
			p = i;
		}
	}
	cout << k << "\n";
}