#include <bits/stdc++.h>
using namespace std;
using ll = long long;


struct Segment {
    vector<int> seg;
    vector<int> lazy;
    int n;

    Segment(int m) {
        n = m;
        seg.resize(4 * n);
        lazy.resize(4 * n);
    }

    int query(int ind, int beg, int end, int l, int r) {
        if (lazy[ind] != 0) {
            seg[ind] = max(seg[ind], lazy[ind]);
            if (beg != end) {
                lazy[2 * ind  + 1] = max(lazy[2 * ind + 1], lazy[ind]);
                lazy[2 * ind + 2] = max(lazy[2 * ind + 2], lazy[ind]); 
            }
            lazy[ind] = 0;
        }

        if (l <= beg && end <= r) {
            return seg[ind];
        }
        else if (beg > r || end < l || beg > end) return 0;
        else {
            int mid = (beg + end) / 2;
            return max(query(ind * 2 + 1, beg, mid, l, r), query(ind * 2 + 2, mid + 1, end, l, r));
        }
    }

    int query(int l, int r) {
        return query(0, 0, n - 1, l, r);
    }


    void update(int ind, int beg, int end, int i, int val) {
        if (lazy[ind] != 0) {
            seg[ind] = max(seg[ind], lazy[ind]);
            if (beg != end) {
                lazy[2 * ind  + 1] = max(lazy[2 * ind + 1], lazy[ind]);
                lazy[2 * ind + 2] = max(lazy[2 * ind + 2], lazy[ind]); 
            }
            lazy[ind] = 0;
        }
        if (beg == i && end == i) {
            seg[ind] = max(seg[ind], val);
        }
        else if (end < i || beg > i) return;
        else {
            int mid = (beg + end) / 2;
            if (i <= mid) {
                update(ind * 2 + 1, beg, mid, i, val);
            }
            else {
                update(ind * 2 + 2, mid + 1, end, i, val);
            }
            seg[ind] = max(seg[ind * 2 + 1], seg[ind * 2 + 2]);
        }
    }

    void update(int i, int val) {
        update(0, 0, n - 1, i, val);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, l, r;
    cin >> n >> l >> r;

    ll a[n];
    ll b[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i];
    }

    sort(b, b + n);

    ll mn[n];
    ll mx[n];

    for (int i = 0; i < n; i++) {
        mn[i] = lower_bound(b, b + n, l - a[i]) - b;
        mx[i] = upper_bound(b, b + n, r - a[i]) - b - 1; 
        a[i] = lower_bound(b, b + n, a[i]) - b;
    }

    Segment seg(n);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (mn[i] <= mx[i]) {
            int here = seg.query(mn[i], mx[i]) + 1;
            ans = max(ans, here);
            seg.update(a[i], here);
        }
        else {
            int here = 1;
            ans = max(ans, here);
            seg.update(a[i], here);
        }
    }

    printf("%i\n", ans);
    
}
