#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("arch=icelake-server")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
struct dsu{
    vector<list<int>> roots;
    vector<int> p;
    vector<int> updates;
    int root(int v){
        if(p[v] == v) return v;
        return p[v] = root(p[v]);
    }
    void update(int v,int u){
        v = root(v);
        u = root(u);
        if(u == v) return;
        updates.push_back(v);
        updates.push_back(u);
        if(roots[u].size() > roots[v].size()) swap(u,v);
        roots[v].merge(roots[u]);
        p[u] = v;
    }
    void init(int n){
        updates.clear();
        p.resize(n);
        roots.resize(n);
        for(int i = 0;i < n;i++){
            p[i] = i;
            roots[i].clear();
            roots[i] = {i};
        }
    }
    void reset(){
        for(auto i:updates){
            p[i] = i;
            roots[i].clear();
            roots[i] = {i};
        }
        updates.clear();
    }
};
struct parity{
    vector<int> par;
    vector<int> history;
    void init(int n){
        par.resize(n);
    }
    void reset(){
        for(auto e:history){
            par[e] = 0;
        }
        history.clear();
    }
    void swap(list<int> &l){
        for(auto e:l){
            history.push_back(e);
            if(par[e] == 1) par[e] = 2;
            else par[e] = 1;
        }
    }
    void equal(int v,int val){
        history.push_back(v);
        par[v] = val;
    }
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin >> n >> m;
    dsu d;
    parity p;
    d.init(n);
    p.init(n);
    int cnt = 1;
    for(int i = 0;i < m;i++){
        int u,v;
        cin >> u >> v;
        u--;
        v--;
        if(d.root(u) == d.root(v)){
            if(p.par[u] == p.par[v]){
                cnt++;
                d.reset();
                p.reset();
                d.update(u,v);
                p.equal(u,1);
                p.equal(v,2);
            }
            else continue;
        }
        else{
            if(p.par[u] == 0 and p.par[v] == 0){
                d.update(u,v);
                p.equal(u,1);
                p.equal(v,2);
            }
            else if(p.par[u] == 0){
                d.update(u,v);
                p.equal(u,3-p.par[v]);
            }
            else if(p.par[v] == 0){
                d.update(u,v);
                p.equal(v,3-p.par[u]);
            }
            else if(p.par[v] == p.par[u]){
                u = d.root(u);
                v = d.root(v);
                if(d.roots[u].size() < d.roots[v].size()){
                    p.swap(d.roots[u]);
                }
                else p.swap(d.roots[v]);
                d.update(u,v);
            }
            else{
                d.update(u,v);
            }
        }
    
    }
    cout << cnt << "\n";
}
