from collections import defaultdict

def dfs(graph, visited, node):
    visited[node] = True
    for neighbor in graph[node]:
        if not visited[neighbor]:
            dfs(graph, visited, neighbor)

def minimum_segments(n, m, conflicts):
    graph = defaultdict(list)
    for a, b in conflicts:
        graph[a].append(b)
        graph[b].append(a)
    
    visited = [False] * (n + 1)
    num_segments = 0
    for i in range(1, n + 1):
        if not visited[i]:
            dfs(graph, visited, i)
            num_segments += 1
    
    return num_segments

n, m = map(int, input().split())
conflicts = [tuple(map(int, input().split())) for _ in range(m)]

print(minimum_segments(n, m, conflicts))
