
#include <iostream>
#include <vector>
#include <queue> 
#include <utility> 
#include <iomanip> 

int main() {
    int n, k;
    std::cin >> n >> k;

    std::vector<double> rates(n);
    std::vector<double> lengths(n);
    std::priority_queue<std::pair<double, int>> pq;

    for (int i = 0; i < n; ++i) {
        std::cin >> rates[i];
    }

    for (int i = 0; i < n; ++i) {
        std::cin >> lengths[i];
    }

    for (int i = 0; i < n; ++i) {
        pq.push(std::make_pair(rates[i] / lengths[i], i));
    }

    double sumTop = 0.0, sumBot = 0.0;

    for (int i = 0; i < k; ++i) {
        auto top = pq.top(); pq.pop();
        sumTop += rates[top.second];
        sumBot += lengths[top.second];
    }

    std::cout << std::fixed << std::setprecision(6) << sumTop / sumBot << std::endl;

    return 0;
}
